/*-
 * ~~~~~~licensing~~~~~~
 * connector-manager
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.connector.manager;

import ru.entaxy.esb.system.connector.entity.Connector;
import ru.entaxy.esb.system.core.template.Template;
import ru.entaxy.esb.system.management.bundle.jpa.dto.BundleDto;
import ru.entaxy.esb.system.management.connector.manager.dto.ConnectorDto;

import java.util.List;

public interface ConnectorManager {

    BundleDto installConnector(ConnectorDto connectorDto) throws Exception;

    BundleDto startConnector(ConnectorDto connectorDto) throws Exception;

    BundleDto startConnector(Connector connector) throws Exception;
    
    BundleDto stopConnector(ConnectorDto connectorDto) throws Exception;

    BundleDto stopConnector(Connector connector) throws Exception;

    BundleDto uninstallConnector(ConnectorDto connectorDto) throws Exception;

    BundleDto uninstallConnector(Connector connector) throws Exception;

    List<ConnectorDto> getListConnector();

    List<Template> getTemplates();

    Template getTemplate(String templateName);
    
    void restore() throws Exception;
}
